/*
Copyright 2020 caicloud authors. All rights reserved.
*/

// Code generated by client-gen. DO NOT EDIT.

package v1alpha1

import (
	v1alpha1 "github.com/caicloud/cyclone/pkg/apis/cyclone/v1alpha1"
	scheme "github.com/caicloud/cyclone/pkg/k8s/clientset/scheme"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
)

// WorkflowTriggersGetter has a method to return a WorkflowTriggerInterface.
// A group's client should implement this interface.
type WorkflowTriggersGetter interface {
	WorkflowTriggers(namespace string) WorkflowTriggerInterface
}

// WorkflowTriggerInterface has methods to work with WorkflowTrigger resources.
type WorkflowTriggerInterface interface {
	Create(*v1alpha1.WorkflowTrigger) (*v1alpha1.WorkflowTrigger, error)
	Update(*v1alpha1.WorkflowTrigger) (*v1alpha1.WorkflowTrigger, error)
	UpdateStatus(*v1alpha1.WorkflowTrigger) (*v1alpha1.WorkflowTrigger, error)
	Delete(name string, options *v1.DeleteOptions) error
	DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error
	Get(name string, options v1.GetOptions) (*v1alpha1.WorkflowTrigger, error)
	List(opts v1.ListOptions) (*v1alpha1.WorkflowTriggerList, error)
	Watch(opts v1.ListOptions) (watch.Interface, error)
	Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1alpha1.WorkflowTrigger, err error)
	WorkflowTriggerExpansion
}

// workflowTriggers implements WorkflowTriggerInterface
type workflowTriggers struct {
	client rest.Interface
	ns     string
}

// newWorkflowTriggers returns a WorkflowTriggers
func newWorkflowTriggers(c *CycloneV1alpha1Client, namespace string) *workflowTriggers {
	return &workflowTriggers{
		client: c.RESTClient(),
		ns:     namespace,
	}
}

// Get takes name of the workflowTrigger, and returns the corresponding workflowTrigger object, and an error if there is any.
func (c *workflowTriggers) Get(name string, options v1.GetOptions) (result *v1alpha1.WorkflowTrigger, err error) {
	result = &v1alpha1.WorkflowTrigger{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("workflowtriggers").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do().
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of WorkflowTriggers that match those selectors.
func (c *workflowTriggers) List(opts v1.ListOptions) (result *v1alpha1.WorkflowTriggerList, err error) {
	result = &v1alpha1.WorkflowTriggerList{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("workflowtriggers").
		VersionedParams(&opts, scheme.ParameterCodec).
		Do().
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested workflowTriggers.
func (c *workflowTriggers) Watch(opts v1.ListOptions) (watch.Interface, error) {
	opts.Watch = true
	return c.client.Get().
		Namespace(c.ns).
		Resource("workflowtriggers").
		VersionedParams(&opts, scheme.ParameterCodec).
		Watch()
}

// Create takes the representation of a workflowTrigger and creates it.  Returns the server's representation of the workflowTrigger, and an error, if there is any.
func (c *workflowTriggers) Create(workflowTrigger *v1alpha1.WorkflowTrigger) (result *v1alpha1.WorkflowTrigger, err error) {
	result = &v1alpha1.WorkflowTrigger{}
	err = c.client.Post().
		Namespace(c.ns).
		Resource("workflowtriggers").
		Body(workflowTrigger).
		Do().
		Into(result)
	return
}

// Update takes the representation of a workflowTrigger and updates it. Returns the server's representation of the workflowTrigger, and an error, if there is any.
func (c *workflowTriggers) Update(workflowTrigger *v1alpha1.WorkflowTrigger) (result *v1alpha1.WorkflowTrigger, err error) {
	result = &v1alpha1.WorkflowTrigger{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("workflowtriggers").
		Name(workflowTrigger.Name).
		Body(workflowTrigger).
		Do().
		Into(result)
	return
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().

func (c *workflowTriggers) UpdateStatus(workflowTrigger *v1alpha1.WorkflowTrigger) (result *v1alpha1.WorkflowTrigger, err error) {
	result = &v1alpha1.WorkflowTrigger{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("workflowtriggers").
		Name(workflowTrigger.Name).
		SubResource("status").
		Body(workflowTrigger).
		Do().
		Into(result)
	return
}

// Delete takes name of the workflowTrigger and deletes it. Returns an error if one occurs.
func (c *workflowTriggers) Delete(name string, options *v1.DeleteOptions) error {
	return c.client.Delete().
		Namespace(c.ns).
		Resource("workflowtriggers").
		Name(name).
		Body(options).
		Do().
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *workflowTriggers) DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error {
	return c.client.Delete().
		Namespace(c.ns).
		Resource("workflowtriggers").
		VersionedParams(&listOptions, scheme.ParameterCodec).
		Body(options).
		Do().
		Error()
}

// Patch applies the patch and returns the patched workflowTrigger.
func (c *workflowTriggers) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1alpha1.WorkflowTrigger, err error) {
	result = &v1alpha1.WorkflowTrigger{}
	err = c.client.Patch(pt).
		Namespace(c.ns).
		Resource("workflowtriggers").
		SubResource(subresources...).
		Name(name).
		Body(data).
		Do().
		Into(result)
	return
}
